
/*  A Bison parser, made from gcl.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PREDICATE	258
#define	CHUNK	259
#define	SEMI	260
#define	OPEN	261
#define	CLOSE	262
#define	DOTDOT	263
#define	DOT	264
#define	BECOMES	265
#define	BLOCK	266
#define	COMMA	267
#define	ARROW	268
#define	COLON	269
#define	SKIP	270
#define	ABORT	271
#define	ARRAY	272
#define	OF	273
#define	DO	274
#define	OD	275
#define	IF	276
#define	FI	277
#define	SWAP	278
#define	OPENBLOCK	279
#define	CLOSEBLOCK	280
#define	UNARY_OP	281
#define	MINUS	282
#define	BINARY_OP	283
#define	ACCESS	284
#define	TYPE	285
#define	ID	286
#define	NUMBER	287

#line 7 "gcl.y"
                                                     

  /* this is needed for the yyprint function below */  
#include<stdio.h>                                      

  /* include the attribute definitions */              
#include"attr.h"                                     

  /* include the output definitions */                 
#include"output.h"                                   

  /* enable parser debugging */                        
#define YYDEBUG 1                                      

  /* redefine the semantic value */                    
#define YYSTYPE Attribute*                             

  /* enable calls of YYPRINT */                        
#define YYPRINT(file, type, value) yyprint (file, type, value)

  /* this is the prototype for yyprint */              
static void                                            
yyprint(FILE *file, int type, YYSTYPE value);          

  /* make sure that our local copy of yylex is         
   * declared with name `yylex' and as a static        
   * function. This should trick the parser into       
   * calling the scanner object stored in              
   * `static_scanner' (see below). */                  

  /* undefine yylex to make sure it isn't renamed      
   * by any command line option (e.g. -P). */          
#undef yylex                                           
  /* declare our local `dummy' yylex */                
static int yylex(YYSTYPE *rvalue);                     
  /* make sure any newer versions of Bison don't       
   * redeclare it differently */                       
#define YYLEX_DECL                                     
#line 94 "gcl.y"
                                                     

  /* include own header only in default case: */       
#ifndef PPARSE_NAME                                    
#include "Ppparse.h"                                 
#endif                                                 

  /* this is a definition of the yyerror routine */    
yyerror (const char *s)                                
{  /* ignore error messages by BISON */                
   /* trick! use s do get around warning `s not used'. */
   if (1==0) fprintf(stderr, "%s", s);               
   return 0;                                           
}                                                      

  /* enable parser debugging */                        
#define YYDEBUG 1                                      

  /* variable to hold the parsed attribute */          
static Attribute *rest=create(null);                   

  /* include the scanner only in the default case: */  
#ifndef PSCAN_NAME                                     
#define PSCAN_NAME Ppscan                              
#include "Ppscan.h"                                  
#endif                                                 

  /* trick the yyparse function to use the scan member 
   * of the scanner class: */                          
static Pscan* static_scanner = NULL;                   
static int yylex( YYSTYPE *rvalue )                    
{                                                      
    return(static_scanner->scan(rvalue));              
}                                                      

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		85
#define	YYFLAG		-32768
#define	YYNTBASE	33

#define YYTRANSLATE(x) ((unsigned)(x) <= 287 ? yytranslate[x] : 52)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     9,    12,    16,    21,    23,    26,    28,
    30,    32,    39,    41,    43,    45,    47,    51,    53,    57,
    59,    61,    65,    67,    71,    74,    78,    80,    82,    84,
    86,    90,    94,    96,   100,   104,   109,   111,   114,   118,
   120,   124,   128,   130,   135
};

static const short yyrhs[] = {    35,
     0,    34,    35,     0,    34,    35,    34,     0,    35,    34,
     0,    35,     5,    33,     0,    34,    35,     5,    33,     0,
     3,     0,     3,    34,     0,    42,     0,    41,     0,    45,
     0,    23,    38,     9,    38,     9,    38,     0,    15,     0,
    16,     0,     4,     0,    36,     0,    37,    10,    37,     0,
    39,     0,    39,    12,    37,     0,    31,     0,    32,     0,
     6,    39,     7,     0,    38,     0,    31,     9,    38,     0,
    26,    38,     0,    39,    40,    39,     0,    28,     0,    27,
     0,    26,     0,    27,     0,    19,    43,    20,     0,    21,
    43,    22,     0,    44,     0,    44,    11,    43,     0,    39,
    13,    33,     0,    24,    46,    33,    25,     0,    47,     0,
    47,    46,     0,    29,    48,     5,     0,    49,     0,    49,
    12,    48,     0,    37,    14,    50,     0,    30,     0,    17,
    51,    18,    30,     0,     6,    39,     8,    39,     7,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   136,   137,   146,   159,   168,   179,   196,   197,   208,   209,
   210,   211,   228,   229,   230,   231,   234,   255,   256,   271,
   272,   273,   276,   277,   278,   279,   294,   295,   298,   299,
   302,   317,   332,   333,   348,   367,   390,   391,   394,   411,
   412,   425,   440,   441,   460
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PREDICATE",
"CHUNK","SEMI","OPEN","CLOSE","DOTDOT","DOT","BECOMES","BLOCK","COMMA","ARROW",
"COLON","SKIP","ABORT","ARRAY","OF","DO","OD","IF","FI","SWAP","OPENBLOCK","CLOSEBLOCK",
"UNARY_OP","MINUS","BINARY_OP","ACCESS","TYPE","ID","NUMBER","stmt_list","predicate",
"stmt","assign","expr_list","simple_expr","expr","binary_op","repetition","selection",
"guarded_list","guarded_stmt","block","decls","decl","type_decls","type_decl",
"type","bounds", NULL
};
#endif

static const short yyr1[] = {     0,
    33,    33,    33,    33,    33,    33,    34,    34,    35,    35,
    35,    35,    35,    35,    35,    35,    36,    37,    37,    38,
    38,    38,    39,    39,    39,    39,    40,    40,    -1,    -1,
    41,    42,    43,    43,    44,    45,    46,    46,    47,    48,
    48,    49,    50,    50,    51
};

static const short yyr2[] = {     0,
     1,     2,     3,     2,     3,     4,     1,     2,     1,     1,
     1,     6,     1,     1,     1,     1,     3,     1,     3,     1,
     1,     3,     1,     3,     2,     3,     1,     1,     1,     1,
     3,     3,     1,     3,     3,     4,     1,     2,     3,     1,
     3,     3,     1,     4,     5
};

static const short yydefact[] = {     0,
     7,    15,     0,    13,    14,     0,     0,     0,     0,     0,
    20,    21,     0,     1,    16,     0,    23,    18,    10,     9,
    11,     8,     0,     0,     0,    33,     0,    20,     0,     0,
     0,    37,    25,     0,     2,     0,     4,     0,     0,    28,
    27,     0,    22,     0,    31,     0,    32,     0,     0,     0,
    40,     0,    38,    24,     0,     3,     5,    17,    19,    26,
    35,    34,     0,     0,    39,     0,    36,     6,     0,     0,
    43,    42,    41,    12,     0,     0,     0,     0,     0,    44,
     0,    45,     0,     0,     0
};

static const short yydefgoto[] = {    52,
    13,    14,    15,    16,    17,    18,    42,    19,    20,    25,
    26,    21,    31,    32,    50,    51,    72,    76
};

static const short yypact[] = {    47,
    15,-32768,    -1,-32768,-32768,    -1,    -1,     3,   -17,     3,
    24,-32768,    71,    11,-32768,    14,-32768,    53,-32768,-32768,
-32768,-32768,     0,    27,    16,    41,    20,-32768,    48,    -1,
    47,   -17,-32768,     3,    12,    47,-32768,    -1,    -1,-32768,
-32768,    -1,-32768,    47,-32768,    -1,-32768,     3,    46,    56,
    52,    44,-32768,-32768,    47,-32768,-32768,-32768,-32768,    -6,
-32768,-32768,    65,    -4,-32768,    -1,-32768,-32768,     3,    76,
-32768,-32768,-32768,-32768,    -1,    66,    21,    55,    -1,-32768,
    31,-32768,    83,    88,-32768
};

static const short yypgoto[] = {     1,
     9,    78,-32768,   -19,    -2,    -3,-32768,-32768,-32768,    -5,
-32768,-32768,    57,-32768,    30,-32768,-32768,-32768
};


#define	YYLAST		103


static const short yytable[] = {    23,
    83,    27,    24,    24,     3,    29,    43,    33,     3,    22,
    49,    30,    70,     1,     1,    36,    55,     1,    58,    59,
    40,    41,    37,    38,    10,    71,    40,    41,    79,    11,
    12,    54,    34,    28,    12,    45,    57,    82,    60,    44,
    62,    47,    24,    56,    61,    63,    49,    40,    41,     1,
     2,    46,     3,    40,    41,    68,    48,    40,    41,    64,
    65,     4,     5,    66,    39,     6,    74,     7,    67,     8,
     9,    77,    10,    69,     2,    81,     3,    11,    12,    40,
    41,    75,    84,    78,    80,     4,     5,    85,    53,     6,
    35,     7,     0,     8,     9,    73,    10,     0,     0,     0,
     0,    11,    12
};

static const short yycheck[] = {     3,
     0,     7,     6,     7,     6,     8,     7,    10,     6,     1,
    30,    29,    17,     3,     3,     5,     5,     3,    38,    39,
    27,    28,    14,    10,    26,    30,    27,    28,     8,    31,
    32,    34,     9,    31,    32,    20,    36,     7,    42,    13,
    46,    22,    46,    35,    44,    48,    66,    27,    28,     3,
     4,    11,     6,    27,    28,    55,     9,    27,    28,    14,
     5,    15,    16,    12,    12,    19,    69,    21,    25,    23,
    24,    75,    26,     9,     4,    79,     6,    31,    32,    27,
    28,     6,     0,    18,    30,    15,    16,     0,    32,    19,
    13,    21,    -1,    23,    24,    66,    26,    -1,    -1,    -1,
    -1,    31,    32
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/gnu/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/gnu/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 136 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 2:
#line 137 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				yyvsp[-1],
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 3:
#line 146 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(force)),
				yyvsp[-1]),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 4:
#line 159 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				yyvsp[-1],
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 5:
#line 168 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				yyvsp[-2],
				yyvsp[-1]),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 6:
#line 179 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				yyvsp[-3],
				create(force)),
				yyvsp[-2]),
				yyvsp[-1]),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 7:
#line 196 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 8:
#line 197 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				yyvsp[-1],
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 9:
#line 208 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 10:
#line 209 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 11:
#line 210 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 12:
#line 211 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				join(
				yyvsp[-5],
				create(" ")),
				yyvsp[-4]),
				yyvsp[-3]),
				yyvsp[-2]),
				yyvsp[-1]),
				yyvsp[0]);
		
		;
    break;}
case 13:
#line 228 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 14:
#line 229 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 15:
#line 230 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 16:
#line 231 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 17:
#line 234 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(" ")),
				create(indent)),
				create(opt5)),
				create(outdent)),
				yyvsp[0]);
		
		;
    break;}
case 18:
#line 255 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 19:
#line 256 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				yyvsp[-1]),
				create(" ")),
				create(opt9)),
				yyvsp[0]);
		
		;
    break;}
case 20:
#line 271 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 21:
#line 272 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 22:
#line 273 "gcl.y"
{rest=yyval=join(yyvsp[-2],join(yyvsp[-1],yyvsp[0]));;
    break;}
case 23:
#line 276 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 24:
#line 277 "gcl.y"
{rest=yyval=join(yyvsp[-2],join(yyvsp[-1],yyvsp[0]));;
    break;}
case 25:
#line 278 "gcl.y"
{rest=yyval=join(yyvsp[-1],yyvsp[0]);;
    break;}
case 26:
#line 279 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]);
		
		;
    break;}
case 27:
#line 294 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 28:
#line 295 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 29:
#line 298 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 30:
#line 299 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 31:
#line 302 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 32:
#line 317 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 33:
#line 332 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 34:
#line 333 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(force)),
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]);
		
		;
    break;}
case 35:
#line 348 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(indent)),
				create(force)),
				yyvsp[0]),
				create(outdent));
		
		;
    break;}
case 36:
#line 367 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				join(
				join(
				join(
				yyvsp[-3],
				create(indent)),
				create(force)),
				yyvsp[-2]),
				create(force)),
				yyvsp[-1]),
				create(outdent)),
				create(force)),
				yyvsp[0]);
		
		;
    break;}
case 37:
#line 390 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 38:
#line 391 "gcl.y"
{rest=yyval=join(yyvsp[-1],yyvsp[0]);;
    break;}
case 39:
#line 394 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]),
				create(force));
		
		;
    break;}
case 40:
#line 411 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 41:
#line 412 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				yyvsp[-2],
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]);
		
		;
    break;}
case 42:
#line 425 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				yyvsp[-2],
				create(" ")),
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]);
		
		;
    break;}
case 43:
#line 440 "gcl.y"
{rest=yyval=yyvsp[0];;
    break;}
case 44:
#line 441 "gcl.y"
{ 
			rest=yyval=
			join(
				join(
				join(
				join(
				join(
				join(
				yyvsp[-3],
				create(" ")),
				yyvsp[-2]),
				create(" ")),
				yyvsp[-1]),
				create(" ")),
				yyvsp[0]);
		
		;
    break;}
case 45:
#line 460 "gcl.y"
{rest=yyval=join(yyvsp[-4],join(yyvsp[-3],join(yyvsp[-2],join(yyvsp[-1],yyvsp[0]))));;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/gnu/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 463 "gcl.y"

/*************************************************     
 * additional pretzel code starts here:          *     
 *************************************************/    

#ifndef PPARSE_NAME                                    
#define PPARSE_NAME Ppparse                            
#endif                                                 

PPARSE_NAME::PPARSE_NAME()                             
{                                                      
}                                                      
PPARSE_NAME::~PPARSE_NAME()                            
{                                                      
    static_scanner = NULL;                             
}                                                      
int PPARSE_NAME::prettyprint(istream* is, ostream* os) 
{                                                      
    Latex_cweb_output ppoutput(*os);                   
    return(prettyprint(is, &ppoutput));                
}                                                      
int PPARSE_NAME::prettyprint(istream* is, Output* outp)
{                                                      
    int ret_val = 0;                                   
    PSCAN_NAME ppscanner(is);                          
    static_scanner = &ppscanner;                       
    ret_val=yyparse();                                 
    while (!(is->eof())) {                             
        char c;                                        
        is->get(c);                                    
    }                                                  
    rest->print(*outp);                                
    return(ret_val);                                   
}                                                      

void PPARSE_NAME::debug_on() { yydebug = 1; }          
void PPARSE_NAME::debug_off() { yydebug = 0; }         

  /* This is a routine to print the semantic value */
static void 
yyprint(FILE *file, int type, YYSTYPE value) {
  Latex_cweb_output os(cerr);
  value->print(os);
}
/*************************************************     
 * optional user defined C code follows here:    *     
 *************************************************/    

